import java.awt.*;
import java.awt.event.*;


public class TwoDMural extends Canvas 
{
	
	final int maxNoShapes=1000;
	int curShape;
	int orgX=100,orgY=100;
	int ox,oy,cx,cy;
	boolean firstTime;
	int curSel=-1;
	
	int polyx;
	int polyy;
	int curpolypt=0;
	
	int l,t,r,b;
	Color curColor=new Color(255,0,0);
	Color transColor=new Color(0,255,0); //Transient Color
	Color selColor=new Color(255,255,255);


	int noOfShapes=0;
	List shapeList;
	
	Shape2d shapes[]=new Shape2d[maxNoShapes];
	
	TwoDMural(List sl)
	{
		shapeList=sl;
		curShape=Shape2d.LINE;
		addMouseListener(new MouAdap());
		addMouseMotionListener(new MouMosAdap());
	}
	
	public void drawShape(Graphics g)
	{
		switch(curShape)
		{
			case Shape2d.LINE:
				g.drawLine(ox,oy,cx,cy);
				break;
			case Shape2d.CIRCLE:
				int r;
				r=Math.abs(ox-cx);
				g.drawArc(ox-r,oy-r,2*r,2*r,0,360);
				break;
			case Shape2d.CLIP:
				g.drawRect(ox,oy,cx-ox,cy-oy);
				break;
			default:
				break;
		}
	}
	
	public void selUnselShape(int index)	
	{
		Graphics g=getGraphics();
		g.setXORMode(getBackground());
		g.setColor(selColor);
		shapes[index].contdraw(g,orgX,orgY);
	}
	
	
	public void erase(int index)
	{
		Graphics g=getGraphics();
		g.setColor(getBackground());
		shapes[index].contdraw(g,orgX,orgY);
	}
	
	
	public void draw(int index)
	{
		Graphics g=getGraphics();
		shapes[index].draw(g,orgX,orgY);
	}
	

	public class MouAdap extends MouseAdapter
	{
		public void mousePressed(MouseEvent e)
		{
			//if(e.get
			if(curShape==Shape2d.POLYGON) return;
			curpolypt=0;
			ox=e.getX();
			oy=e.getY();
			cx=ox;
			cy=oy;
			firstTime=true;
		}
		
		public void mouseReleased(MouseEvent e)
		{
			if(curShape==Shape2d.POLYGON) return;
			curpolypt=0;
			cx=e.getX();
			cy=e.getY();
			Graphics g=getGraphics();
			g.setPaintMode();
			g.setColor(curColor);
			drawShape(g);
			switch(curShape)
			{
				case Shape2d.LINE:
					g.drawLine(ox,oy,cx,cy);
					MyPolygon po=new MyPolygon(curColor.getRGB());
					po.addPoint(ox-orgX,orgY-oy);
					po.addPoint(cx-orgX,orgY-cy);
					//po.addPoint(cx-orgX,orgY-cy);
					//po.addPoint(ox-orgX,orgY-oy);
					shapes[noOfShapes++]=(Shape2d)po;
					po.draw(g,orgX,orgY);
					shapeList.add("Line "+noOfShapes);
					break;
				case Shape2d.CIRCLE:
					int r;
					r=Math.abs(ox-cx);
					g.drawArc(ox-r,oy-r,2*r,2*r,0,360);
					shapes[noOfShapes++]=(Shape2d)new Circle(ox-orgX,orgY-oy,r,curColor.getRGB());
					shapeList.add("Circle "+noOfShapes);
					break;
				case Shape2d.CLIP:
					int ind;
					ind=shapeList.getSelectedIndex();
					if(ind!=-1)
					{
						((MyPolygon)shapes[ind]).clip(ox-orgX,orgY-oy,cx-orgX,orgY-cy);
					}
					repaint();
					break;
				default:
					break;
			}
		}
		public void mouseClicked(MouseEvent e)
		{
			if(curShape!=Shape2d.POLYGON) return;
			if((e.getModifiers() & e.BUTTON1_MASK)==e.BUTTON1_MASK)
			{
				if(curpolypt==0)
				{
					shapes[noOfShapes++]=(Shape2d)new MyPolygon(curColor.getRGB());
					polyx=e.getX();
					polyy=e.getY();
				}
					
				((MyPolygon)shapes[noOfShapes-1]).addPoint(e.getX()-orgX,orgY-e.getY());
				((MyPolygon)shapes[noOfShapes-1]).draw(getGraphics(),orgX,orgY);
				curpolypt++;
				return;
			}
			if((e.getModifiers() & e.BUTTON3_MASK)==e.BUTTON3_MASK)
			{
				if(curpolypt==0) return;
				curpolypt=0;		
				shapeList.add("Polygon"+noOfShapes);
				((MyPolygon)shapes[noOfShapes-1]).addPoint(polyx-orgX,orgY-polyy);
				((MyPolygon)shapes[noOfShapes-1]).draw(getGraphics(),orgX,orgY);
				return;
			}
		}
	}
	
	public void paint(Graphics g)
	{
		int i;
		Dimension d=getSize();
		g.setColor(Color.blue);
		g.drawLine(orgX,0,orgX,d.height);
		g.drawLine(0,orgY,d.width,orgY);
		for(i=0;i<noOfShapes;++i)
		{
			shapes[i].draw(g,orgX,orgY);
		}
		if(curSel!=-1)
		{
			selUnselShape(curSel);
		}
	}
	
	public class MouMosAdap extends MouseMotionAdapter
	{
		public void mouseDragged(MouseEvent e)
		{
			if(curShape==Shape2d.POLYGON) return;
			curpolypt=0;
			Graphics g=getGraphics();
			if(firstTime==true)
			{
				firstTime=false;
				cx=e.getX();
				cy=e.getY();
				g.setXORMode(getBackground());
				g.setColor(transColor);
				drawShape(g);
			}
			else
			{
				g.setXORMode(getBackground());
				g.setColor(transColor);
				drawShape(g);
				cx=e.getX();
				cy=e.getY();
				drawShape(g);
			}
		}
	}
	
}